
CC = CC -DNDEBUG -O2
cc = cc -DNDEBUG -O2

AR = ar csr $@
RM = rm -f

OBJDIR = .
INCDIR = .
LIBDIR = .

PU_OBJ = ${OBJDIR}/pu.o ${OBJDIR}/puButton.o \
 ${OBJDIR}/puText.o ${OBJDIR}/puObject.o \
 ${OBJDIR}/puFrame.o ${OBJDIR}/puInterface.o \
 ${OBJDIR}/puPopup.o ${OBJDIR}/puBox.o \
 ${OBJDIR}/puMenuBar.o ${OBJDIR}/puPopupMenu.o \
 ${OBJDIR}/puOneShot.o ${OBJDIR}/puInput.o \
 ${OBJDIR}/puButtonBox.o \
 ${OBJDIR}/puSlider.o ${OBJDIR}/puDialogBox.o

INC = pu.h puLocal.h

#
# Build the library.
#

${LIBDIR}/libpu.a : ${PU_OBJ}
	@${RM} $@
	${AR} ${PU_OBJ}

#
# Build the classes.
#

${OBJDIR}/puOneShot.o : puOneShot.cxx ${INC}
	${CC} -I${INCDIR} -c puOneShot.cxx -o $@
${OBJDIR}/puInput.o : puInput.cxx ${INC}
	${CC} -I${INCDIR} -c puInput.cxx -o $@
${OBJDIR}/puButton.o : puButton.cxx ${INC}
	${CC} -I${INCDIR} -c puButton.cxx -o $@
${OBJDIR}/puMenuBar.o : puMenuBar.cxx ${INC}
	${CC} -I${INCDIR} -c puMenuBar.cxx -o $@
${OBJDIR}/puFrame.o : puFrame.cxx ${INC}
	${CC} -I${INCDIR} -c puFrame.cxx -o $@
${OBJDIR}/puObject.o : puObject.cxx ${INC}
	${CC} -I${INCDIR} -c puObject.cxx -o $@
${OBJDIR}/puButtonBox.o : puButtonBox.cxx ${INC}
	${CC} -I${INCDIR} -c puButtonBox.cxx -o $@
${OBJDIR}/puSlider.o : puSlider.cxx ${INC}
	${CC} -I${INCDIR} -c puSlider.cxx -o $@
${OBJDIR}/puInterface.o : puInterface.cxx ${INC}
	${CC} -I${INCDIR} -c puInterface.cxx -o $@
${OBJDIR}/puPopup.o : puPopup.cxx ${INC}
	${CC} -I${INCDIR} -c puPopup.cxx -o $@
${OBJDIR}/puDialogBox.o : puDialogBox.cxx ${INC}
	${CC} -I${INCDIR} -c puDialogBox.cxx -o $@
${OBJDIR}/puPopupMenu.o : puPopupMenu.cxx ${INC}
	${CC} -I${INCDIR} -c puPopupMenu.cxx -o $@
${OBJDIR}/puText.o : puText.cxx ${INC}
	${CC} -I${INCDIR} -c puText.cxx -o $@
${OBJDIR}/puBox.o : puBox.cxx ${INC}
	${CC} -I${INCDIR} -c puBox.cxx -o $@
${OBJDIR}/pu.o : pu.cxx ${INC}
	${CC} -I${INCDIR} -c pu.cxx -o $@

#
# clean
#

clean :
	@${RM} ${LIBDIR}/libpu.a ${PU_OBJ}
