// -*- mode: c++ -*-
// $Id: controls.h,v 1.12 2000/08/09 16:45:00 jianbo Exp $
// $Source: /tools/cvs-repos/illustrate/src/controls.h,v $

#ifndef __CONTROLS_H__
#define __CONTROLS_H__

#include <pu.h>

class SilViewer;

class Controls {
public:
  static void createWindow(char *title = 0);

  // silhouettes
  static SilViewer *silviewer;

  // window management
  static int getWindow() { return _winId; };
  static int getWidth() { return _width; };
  static int getHeight() { return _height; };

private:
  // controls window
  static int _winId;
  static int _width, _height;
  static char _title[80];

  static char _depthInfo[10];
  static puText *_depthLabel;

  static puButton *btndrawRays;
  static puButton *btndrawBoundary;
  static puButton *btndrawSilhouetteEdges;
  static puButton *btndrawMeshGrid;
  static puButton *btndrawFaceNormal;
  static puButton *btndrawWireframe;
  static puButton *btnlighting;

  static void display( void );
  static void mouse( int button, int state, int x, int y );
  static void motion( int x, int y );
  static void keyboard( unsigned char key, int x, int y );

  static void redisplay();

  static void createElements( int& width, int& height);
  static puText* createLabel(char *text, int x, int y);
  static puOneShot* createButton(char *text, int x, int y);
  static puButton* createRadioButton(char *text, int x, int y);

  static void quit(puObject *b);
  static void subdivide(puObject *b);
  static void outputCamera(puObject *b);
  static void inputCamera(puObject *b);
  static void recomputeSilhouettes(puObject *b);

  // illustration
  static void takeBoundary(puObject *b);
  static void visibility(puObject *b);
  static void drawHiddenCurves(puObject *b);
  static void distinctChainColors(puObject *b);
  static void drawIntersections(puObject *b);
  static void drawQI(puObject *b);
  static void drawSilGrid(puObject *b);
  static void showDualMesh(puObject *b);

  // mesh
  static void setMeshButtons(bool v);
  static void viewMesh(puObject *b);
  static void drawSilhouetteEdges(puObject *b);
  static void drawBoundary(puObject *b);
  static void lighting(puObject *b);
  static void drawFaceNormal(puObject *b);
  static void drawWireframe(puObject *b);
  static void drawRays(puObject *b);
  static void drawMeshGrid(puObject *b);

  // constants
  static const int buttonWidth;
  static const int buttonHeight;
  static const int inputWidth;
  static const int inputHeight;
  static const int radioButtonWidth;
  static const int radioButtonHeight;
  static const int radioButtonTextOffset;
  static const int sliderWidth;
  static const int sliderHeight;
  static const int textLabelHeight;
  static const int buttonOffset;
};

#endif /* __CONTROLS_H__ */
