// -*- Mode: c++ -*-
// $Id: main.cpp,v 1.6 2000/08/08 21:28:16 jianbo Exp $
// $Source: /tools/cvs-repos/illustrate/src/main.cpp,v $


#include <GL/glut.h>

#include "options.h"
#include "silviewer.h"
#include "dualviewer.h"
#include "controls.h"

int main(int argc, char ** argv) {

  glutInit(&argc, argv);
  Options::readCommandLine(argc, argv);

  // control window
  Controls::createWindow();

  // illustration window
  SilViewer sv("illustration", Options::width, Options::height);

  // get mesh
  if ( ! sv.readMesh(Options::inputfile) ) return 0;
  sv.subdivide(Options::depth);
  sv.setupViewer();

  // initialize silhouette
  sv.initSilhouettes();

  Controls::silviewer = &sv;

  glutMainLoop();

  return 0;
};
