// -*- mode: c++ -*-
// $Id: options.h,v 1.11 2000/08/09 16:45:00 jianbo Exp $
// $Source: /tools/cvs-repos/illustrate/src/options.h,v $

#ifndef __OPTIONS_H__
#define __OPTIONS_H__

class Options {
 public:
  // threshold
  static const double EPSILON;

  // mesh file name
  static char *inputfile;

  // camera file name
  static char *camerafile;

  // subdivision depth
  static int depth;
  static int maxDepth;

  // window size
  static int width;
  static int height;

  // dual mesh window size
  static int dualWinSize;

  // mesh viewer options
  static int drawSilhouetteEdges;
  static int drawBoundary;
  static int drawWireframe;
  static int lighting;
  static int drawFaceNormal;
  static int drawRays;
  static int drawMeshGrid;

  // illustration options
  static int takeBoundary;
  static int visibility;
  static int drawHiddenCurves;
  static int distinctChainColors;
  static int drawIntersections;
  static int drawQI;
  static int drawSilGrid;

  // command line parser
  static void readCommandLine(int argc, char ** argv);
};

#endif /* __OPTIONS_H__ */
