// -*- mode: c++ -*-
// $Id: viewer.h,v 1.1 2000/07/06 22:30:44 jianbo Exp $
// $Source: /tools/cvs-repos/illustrate/src/viewer.h,v $

#ifndef __VIEWER_H__
#define __VIEWER_H__

#include "compat.h"
#include <vector>

class Viewer {
public:
  Viewer(char *title = 0, int width = 300, int height = 300);
  virtual ~Viewer();

  // window management
  int getWindow() const { return _winId; };
  int getWidth() const { return _width; };
  int getHeight() const { return _height; };

  // redisplay window
  virtual void redisplay();

protected:
  // window
  int _winId;
  int _width, _height;
  char _title[64];

  // virtual callback functions
  virtual void display() { };
  virtual void reshape(int w, int h);
  virtual void mouse(int button, int state, int x, int y) { };
  virtual void motion(int x, int y) { };
  virtual void keyboard(unsigned char key, int x, int y) { };

  // glut functions
  static void _display();
  static void _reshape(int w, int h);
  static void _mouse(int button, int state, int x, int y);
  static void _motion(int x, int y);
  static void _keyboard(unsigned char key, int x, int y);

  // constants
  static const float depthOffset;

  // objects
  static vector<Viewer*> _viewer;
  static Viewer* getCurrentViewer();
};

#endif /* __VIEWER_H__ */
